unit NIST_Type_8_data_converter_main_form;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TMainForm = class(TForm)
    LabelWidth: TLabel;
    LabelHeight: TLabel;
    ConvertToType8Button: TButton;
    ConvertFromType8Button: TButton;
    EditWidth: TEdit;
    EditHeight: TEdit;
    ComboBoxCompression: TComboBox;
    OpenButton: TButton;
    SaveButton: TButton;
    ScrollBox1: TScrollBox;
    OutputImage: TImage;
    procedure OpenButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure ConvertToType8ButtonClick(Sender: TObject);
    procedure ConvertFromType8ButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bitmap : HBitmap;
    open_dialog : TOpenDialog;
    save_dialog : TSaveDialog;
  end;


{ WSQ library declarations }

{ WSQ library declarations }
function GenerateWSQLibrarySerialNumber():PAnsiChar; cdecl; external 'WSQ_library64.dll' name 'GenerateWSQLibrarySerialNumber';
function UnlockWSQLibrary(const authorization_code: PAnsiChar):Integer; cdecl; external 'WSQ_library64.dll' name 'UnlockWSQLibrary';

function CreateBMPFromFile (const file_name: PAnsiChar): HBitmap; cdecl; external 'WSQ_library64.dll' name 'CreateBMPFromFile';
function SaveBMPToFile( const bitmap: HBITMAP;  const filename: PAnsiChar; filetype: Integer):Integer; cdecl; external 'WSQ_library64.dll' name 'SaveBMPToFile';
function CreateBMPFromWSQByteArray (input_wsq_byte_array: PAnsiChar; const size_of_input_wsq_byte_array: Integer): HBitmap; cdecl; external 'WSQ_library64.dll' name 'CreateBMPFromWSQByteArray';
function SaveWSQByteArrayToImageFile(input_wsq_byte_array: PAnsiChar; const size_of_input_wsq_byte_array: Integer;  const filename: PAnsiChar; filetype: Integer):Integer; cdecl; external 'WSQ_library64.dll' name 'SaveWSQByteArrayToImageFile';
procedure SetShowFilePropertiesDialog(file_properties_dialog: Integer); cdecl; external 'WSQ_library64.dll' name 'SetShowFilePropertiesDialog';
procedure ShowFileConverter(); cdecl; external 'WSQ_library64.dll' name 'ShowFileConverter';
function WSQ_decode_stream( input_data_stream: PAnsiChar; const input_stream_length: Integer; output_data_stream: PPCHAR; width: PInteger; height: PInteger; ppi: PInteger; comment_text: PPCHAR):Integer; cdecl; external 'WSQ_library64.dll' name 'WSQ_decode_stream';
function WSQ_encode_stream(input_data_stream: PAnsiChar; const width: Integer; const height: Integer; const bitrate:Double;
				   const ppi: Integer; comment_text: PAnsiChar; output_data_stream: PPCHAR; output_stream_length: PInteger):Integer; cdecl; external 'WSQ_library64.dll' name 'WSQ_encode_stream';
function ConvertHBITMAPtoGrayScale256 (const bitmap: HBITMAP): HBitmap; cdecl; external 'WSQ_library64.dll' name 'ConvertHBITMAPtoGrayScale256';
function SaveHBITMAPtoFileAsGrayScale256BMP(const bitmap: HBITMAP;  const filename: PAnsiChar):Integer; cdecl; external 'WSQ_library64.dll' name 'SaveHBITMAPtoFileAsGrayScale256BMP';

function CreateHBITMAPfromNISTType8BinaryField(type8_width: Integer; type8_height: Integer; type8_compression_type: Integer; type8_input_byte_array: PAnsiChar; type8_input_byte_array_size: Integer): HBITMAP; cdecl; external 'WSQ_library64.dll' name 'CreateHBITMAPfromNISTType8BinaryField';
//function CreateHBITMAPfromNISTType8UncompressedBinaryField(type8_width: Integer; type8_height: Integer; type8_input_byte_array: PAnsiChar; type8_input_byte_array_size: Integer): HBITMAP; cdecl; external 'WSQ_library64.dll' name 'CreateHBITMAPfromNISTType8UncompressedBinaryField';
//function CreateHBITMAPfromNISTType8CompressedBinaryField(type8_width: Integer; type8_height: Integer; type8_input_byte_array: PAnsiChar; type8_input_byte_array_size: Integer): HBITMAP; cdecl; external 'WSQ_library64.dll' name 'CreateHBITMAPfromNISTType8CompressedBinaryField';

function CreateNISTType8BinaryFieldfromHBITMAP(const input_HBITMAP: HBITMAP; type8_compression_type: Integer): PAnsiChar; cdecl; external 'WSQ_library64.dll' name 'CreateNISTType8BinaryFieldfromHBITMAP';
//function CreateNISTType8UncompressedBinaryFieldfromHBITMAP(const input_HBITMAP: HBITMAP): PAnsiChar; cdecl; external 'WSQ_library64.dll' name 'CreateNISTType8UncompressedBinaryFieldfromHBITMAP';
//function CreateNISTType8CompressedBinaryFieldfromHBITMAP(const input_HBITMAP: HBITMAP): PAnsiChar; cdecl; external 'WSQ_library64.dll' name 'CreateNISTType8CompressedBinaryFieldfromHBITMAP';

function ReadType8DataCompressionType(): Integer; cdecl; external 'WSQ_library64.dll' name 'ReadType8DataCompressionType';
function ReadType8DataWidth(): Integer; cdecl; external 'WSQ_library64.dll' name 'ReadType8DataWidth';
function ReadType8DataHeight(): Integer; cdecl; external 'WSQ_library64.dll' name 'ReadType8DataHeight';
function ReadSizeOfNISTType8BinaryField(): Integer; cdecl; external 'WSQ_library64.dll' name 'ReadSizeOfNISTType8BinaryField';
function SetNISTType8ImageColorInversion(in_uncompressed_type8_image_inverted: Integer; out_uncompressed_type8_image_inverted: Integer; in_compressed_type8_image_inverted: Integer; out_compressed_type8_image_inverted: Integer): Integer; cdecl; external 'WSQ_library64.dll' name 'SetNISTType8ImageColorInversion';




var
  MainForm: TMainForm;


   size_of_type8_binary_field: Integer;
   type8_image_width, type8_image_height: Integer;
   type8_image_compression_type: Integer;
   type8_image_size_txt_file: String;
   save_type8_binary_field_filename: String;

   iFileHandle, iFileLength: Integer;
   txtf: TextFile;

   type8_input_data_stream, type8_output_data_stream: PAnsiChar;
   type8_input_stream_length, type8_output_stream_length: Integer;

   n: Integer;


implementation

{$R *.dfm}

procedure TMainForm.ConvertFromType8ButtonClick(Sender: TObject);
begin


OpenButton.Enabled := false;
SaveButton.Enabled := false;
ConvertFromType8Button.Enabled := false;
ConvertToType8Button.Enabled := false;


	type8_image_width := 0;
	type8_image_height := 0;
	type8_image_compression_type := 0;

    open_dialog.Filter := 'Binary files|*.bin';
//    open_dialog.Filter := 'All files|*.*';
	if ( open_dialog.Execute() ) then
  begin


   iFileHandle := FileOpen(open_dialog.FileName, fmOpenRead);
   iFileLength := FileSeek(iFileHandle,0,2);
   FileSeek(iFileHandle,0,0);
   type8_input_data_stream := PAnsiChar(AllocMem(iFileLength + 1));
   type8_input_stream_length := FileRead(iFileHandle, type8_input_data_stream^, iFileLength);
   FileClose(iFileHandle);


   type8_image_size_txt_file := ChangeFileExt(open_dialog.FileName, '.txt');

   if(FileExists(type8_image_size_txt_file)) then
   begin

   AssignFile(txtf, type8_image_size_txt_file);

   try
     try
      Reset(txtf);
      //Warning: fails to read UTF-8 txt file
      readLn(txtf, type8_image_compression_type);
      readLn(txtf, type8_image_width);
      readLn(txtf, type8_image_height);
     except
       ShowMessage('Error reading file:' + #13#10 + type8_image_size_txt_file);
     end;
   finally
      CloseFile(txtf);
   end;

     EditWidth.Text := IntToStr(type8_image_width);
     EditHeight.Text := IntToStr(type8_image_height);
     ComboBoxCompression.ItemIndex := type8_image_compression_type;

   end //if(FileExists(type8_image_size_txt_file))
   else
   begin
     type8_image_width := StrToIntDef(EditWidth.Text, 0);
     type8_image_height := StrToIntDef(EditHeight.Text, 0);
     type8_image_compression_type := ComboBoxCompression.ItemIndex;
   end;//if(FileExists(type8_image_size_txt_file)) then


   if((type8_image_width = 0) or (type8_image_height = 0)) then
   begin
   Application.MessageBox( 'You must manually set the type8_width and type8_height and compression type of the image.', 'Warning', MB_OK );
   ConvertFromType8Button.Enabled := true;
   OpenButton.Enabled := true;
   exit;
   end;


// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image

       OutputImage.Picture.Bitmap.Handle := CreateHBITMAPfromNISTType8BinaryField(type8_image_width, type8_image_height, type8_image_compression_type, type8_input_data_stream, type8_input_stream_length);

//       if(type8_image_compression_type = 0) then
//       OutputImage.Picture.Bitmap.Handle := CreateHBITMAPfromNISTType8UncompressedBinaryField(type8_image_width, type8_image_height, type8_input_data_stream, type8_input_stream_length)
//      else
//      OutputImage.Picture.Bitmap.Handle := CreateHBITMAPfromNISTType8CompressedBinaryField(type8_image_width, type8_image_height, type8_input_data_stream, type8_input_stream_length);

        if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           ConvertToType8Button.Enabled := True;
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


	end;//if ( open_dialog.Execute() )



  OpenButton.Enabled := true;
  SaveButton.Enabled := true;
  ConvertFromType8Button.Enabled := true;
  ConvertToType8Button.Enabled := true;


end;
//---------------------------------------------------------------------------




procedure TMainForm.ConvertToType8ButtonClick(Sender: TObject);
begin

  save_dialog.Filter := 'BIN Files (*.bin)|*.bin';
  save_dialog.DefaultExt := 'bin';

 if save_dialog.Execute() then
 begin



  OpenButton.Enabled := false;
  SaveButton.Enabled := false;
  ConvertFromType8Button.Enabled := false;
  ConvertToType8Button.Enabled := false;



	type8_image_width := OutputImage.Picture.Bitmap.Width;
	type8_image_height := OutputImage.Picture.Bitmap.Height;

	EditWidth.Text := IntToStr(type8_image_width);
	EditHeight.Text := IntToStr(type8_image_height);

	type8_image_compression_type := ComboBoxCompression.ItemIndex;

  type8_image_size_txt_file := ChangeFileExt(save_dialog.FileName, '.txt');


  with TStringList.Create do
    try
       Add(IntToStr(type8_image_compression_type));
       Add(IntToStr(type8_image_width));
       Add(IntToStr(type8_image_height));
       SaveToFile(type8_image_size_txt_file);
    finally
      Free;
    end;


	 type8_output_data_stream := CreateNISTType8BinaryFieldfromHBITMAP(OutputImage.Picture.Bitmap.Handle, type8_image_compression_type);

 //  if(type8_image_compression_type = 0) then
 //	 type8_output_data_stream := CreateNISTType8UncompressedBinaryFieldfromHBITMAP(OutputImage.Picture.Bitmap.Handle)
 //  else
 //	 type8_output_data_stream := CreateNISTType8CompressedBinaryFieldfromHBITMAP(OutputImage.Picture.Bitmap.Handle);


	 type8_output_stream_length := ReadSizeOfNISTType8BinaryField();


	save_type8_binary_field_filename := ChangeFileExt(save_dialog.FileName, '.bin');


  iFileHandle := FileCreate(PCHAR(save_type8_binary_field_filename));
  FileWrite(iFileHandle, type8_output_data_stream^, type8_output_stream_length);
  FileClose(iFileHandle);


	ShowMessage('The converted file was saved as:' + #13#10 + save_type8_binary_field_filename);


  OpenButton.Enabled := true;
  SaveButton.Enabled := true;
	ConvertFromType8Button.Enabled := true;
	ConvertToType8Button.Enabled := true;


 end; //if save_dialog.Execute() then

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin

   SaveButton.Enabled := false;
   ConvertToType8Button.Enabled := false;

   open_dialog := TOpenDialog.Create(MainForm);
   save_dialog := TSaveDialog.Create(MainForm);
   bitmap := HBitmap(NIL);

   ComboBoxCompression.Items.Add('Uncompressed');
   ComboBoxCompression.Items.Add('ANSI/EIA-538-1988 facsimile compression');
   ComboBoxCompression.ItemIndex := 0;

   EditWidth.Text := '0';
   EditHeight.Text := '0';



// SetNISTType8ImageColorInversion(int in_uncompressed_type8_image_inverted, int out_uncompressed_type8_image_inverted, int in_compressed_type8_image_inverted, int out_compressed_type8_image_inverted);
// SetNISTType8ImageColorInversion(0,1,0,0); // inverted color HBITMAP
// SetNISTType8ImageColorInversion(1,0,1,1); // inverted color Type-8 image


end;

procedure TMainForm.OpenButtonClick(Sender: TObject);
begin

    open_dialog.Filter := 'All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jpeg;*.jp2;*.jpc;' +
    '*.png;*.gif;*.tga;*.pcx;*.ppm;*.pgm;*.ico;*.wmf;*.wbmp;*.ska;*.mng;*.pnm;*.ras;*.raw;|' +
    'FBI Wavelet Scalar Quantization (*.wsq)|*.wsq|' +
    'Windows Bitmap Graphics (*.bmp)|*.bmp|' +
    'Macintosh Tagged Information File Format images (*.tiff)|*.tiff|' +
    'PC Tagged Information File Format images (*.tif)|*.tif|' +
    'Joint Photographic Experts Group images (*.jpg)|*.jpg|' +
    'Joint Photographic Experts Group images (*.jpeg)|*.jpeg|' +
    'JPEG2000 Part 1 images (*.jp2)|*.jp2|' +
    'JPEG2000 Code Stream images (*.jpc)|*.jpc|' +
    'Portable Network Graphics images (*.png)|*.png|' +
    'Compuserve Graphic Interchange Format images (*.gif)|*.gif|' +
    'Truevision Targa Graphic images (*.tga )|*.tga|' +
    'ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)|*.pcx|' +
    'Portable Pixel Map Images (*.ppm)|*.ppm|' +
    'Portable Gray Map Images (*.pgm)|*.pgm|' +
    'Portable Bitmap Images (*.pbm)|*.pbm|' +
    'Windows Icons (*.ico)|*.ico|' +
    'Windows Metafiles (*.wmf)|*.wmf|' +
    'Wireless Bitmap File Format (*.wbmp)|*.wbmp|' +
    'SKA Format images (*.ska)|*.ska|' +
    'Muti-image Network Graphic Animation (*.mng)|*.mng|' +
    'PBM Portable Any Map Graphic Bitmap (*.pnm)|*.pnm|' +
    'Sun Graphic (*.ras)|*.ras|' +
    'RAW Graphic (*.raw)|*.raw';



if open_dialog.Execute() then
begin

// Take and use Handle of HBitmap directly from WSQ image library DLL.
// If the WSQ image library is called to load or save another picture, you will lose the current image
       OutputImage.Picture.Bitmap.Handle := CreateBMPFromFile( PAnsiChar(System.UTF8Encode(open_dialog.FileName)));

        if ( OutputImage.Picture.Bitmap.Handle <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;


{
//Make a copy of HBitmap into OutputImage->Picture

     bitmap := CreateBMPFromFile( PAnsiChar(System.UTF8Encode(open_dialog.FileName)));

        if ( bitmap <> HBitmap(NIL)) then
        begin
           SaveButton.Enabled := True;
           OutputImage.Picture.Bitmap.Handle  := HBitmap(CopyImage(bitmap, IMAGE_BITMAP, 0, 0,LR_COPYRETURNORG));
           OutputImage.Height := OutputImage.Picture.Bitmap.Height;
           OutputImage.Width := OutputImage.Picture.Bitmap.Width;
           Invalidate;
        end
        else
        begin
            Application.MessageBox(PCHAR('Unable to load file'), PCHAR('WSQ library error'), MB_OK or MB_ICONERROR );
        end;
}




end;

end;



procedure TMainForm.SaveButtonClick(Sender: TObject);
begin

    save_dialog.Filter := 'WSQ Files (*.wsq)|*.wsq|' + // 1
'Windows BMP (*.bmp)|*.bmp|' + // 2
'TIFF Files (*.tif)|*.tif|' + // 3
'PNG Files (*.png)|*.png|' + // 4
'JPEG Files (*.jpg)|*.jpg|' + // 5
'Targa Files (*.tga)|*.tga|' + // 6
'SGI Files (*.rgb)|*.rgb|' + // 7
'JPEG-2000 Part-1 (*.jp2)|*.jp2|' + // 8
'JPEG-2000 Code Stream (*.jpc)|*.jpc|' + // 9
'PBM - Portable Bitmap Format (*.pbm)|*.pbm|' + // 10
'PGM - Portable Graymap Format (*.pgm)|*.pgm|' + // 11
'PPM - Portable Pixmap Format (*.ppm)|*.ppm|' + // 12
'GIF Files (*.gif)|*.gif|' + // 13
'PNM Files (*.pnm)|*.pnm|' + // 14
'RAS Files (*.ras)|*.ras|' + // 15
'MNG Files (*.mng)|*.mng|' + // 16
'PCX Files (*.pcx)|*.pcx'; // 17


    save_dialog.DefaultExt := 'wsq';


if save_dialog.Execute() then
begin

       SetShowFilePropertiesDialog(1);
       SaveBMPToFile( OutputImage.Picture.Bitmap.Handle, PAnsiChar(System.UTF8Encode(save_dialog.FileName)), save_dialog.FilterIndex);

end;
end;




end.
